<template>
  <div class="header-wrapper" :class="{'fixed': scrolled}">
    <div class="header">
      <div
        class="burger"
        @click="openMenu"
        :class="{ 'burger-open': isOpenMenu }"
      >
        <span></span><span></span><span></span>
      </div>
      <div class="header-flex-block">
        <RouterLink
          :to="`/${this.langContent}/`"
          class="logo"
        >
          <img
            :src="logo.image"
            :alt="logo.link && logo.link.title"
          />
        </RouterLink>
        <a
          v-if="avardBtn.content"
          :href="avardBtn.link && avardBtn.link.href"
          :title="avardBtn.link && avardBtn.link.title"
          class="award"
        >
          {{ avardBtn.content && avardBtn.content.before }}
          <div class="award-number">
            <span>{{ avardBtn.content && avardBtn.content.in }}</span>
            <img
              :src="avardBtn.image"
              alt=""
            />
          </div>
          {{ avardBtn.content && avardBtn.content.after }}
        </a>
      </div>
      <nav class="header-nav">
        <RouterLink
          v-for="link in links"
          :key="link.index"
          :to="`/${this.langContent}/` + link.code"
          class="header-link"
          :custom="link.subMenu ? true : false"
        >
          <span>
            {{ link.name }}
            <div
              v-if="link.subMenu"
              class="header-nav-select"
            >
              <div
                v-for="item in link.subMenu"
                :key="item.id"
                @click="clickSubLink(item.code)"
                class="header-nav-select-item"
              >
                <div v-html="item.name"></div>
              </div></div
          ></span>
        </RouterLink>
      </nav>
      <div class="header-flex-block">
        <div
          v-if="languages"
          class="lang-wrapper"
        >
          <div
            v-for="item in languages"
            :key="item.code"
            class="lang"
            :class="{ active: langContent === item.code }"
            @click="changeLanguage(item)"
          >
            {{ item.name }}
          </div>
        </div>
        <div
          class="mail-box"
          @click="openPopupForm"
        >
          <div class="icon-mail">
            <img
              :src="popup.image"
              :alt="popup.code"
            />
          </div>
          <span>{{ popup.name }}</span>
        </div>
      </div>
    </div>
    <transition name="fade">
      <div
        class="mob-menu"
        v-if="isOpenMenu"
        :class="{ active: isOpenMenu }"
      >
      <div class="header-flex-block-mob">
        <RouterLink
          :to="`/${this.langContent}/`"
          class="logo"
          @click="openMenu"
        >
          <img
            :src="logo.image"
            :alt="logo.link && logo.link.title"
          />
        </RouterLink>
        <a
          v-if="avardBtn.content"
          :href="avardBtn.link && avardBtn.link.href"
          :title="avardBtn.link && avardBtn.link.title"
          class="award"
        >
          {{ avardBtn.content && avardBtn.content.before }}
          <div class="award-number">
            <span>{{ avardBtn.content && avardBtn.content.in }}</span>
            <img
              :src="avardBtn.image"
              alt=""
            />
          </div>
          {{ avardBtn.content && avardBtn.content.after }}
        </a>
      </div>
      <div
          v-if="languages"
          class="lang-wrapper"
        >
          <div
            v-for="item in languages"
            :key="item.code"
            class="lang"
            :class="{ active: langContent === item.code }"
            @click="changeLanguage(item)"
          >
            {{ item.name }}
          </div>
        </div>
        <nav class="header-nav-mob">
          <RouterLink
            v-for="link in links"
            :key="link.index"
            :to="`/${this.langContent}/` + link.code"
            @click="openMenu"
            class="header-link-mob"
            :custom="link.subMenu ? true : false"
          >
            <span>
              {{ link.name }}
              <div
                v-if="link.subMenu"
                class="header-nav-select-mob"
              >
                <div
                  v-for="item in link.subMenu"
                  :key="item.id"
                  @click="clickSubLink(item.code)"
                  class="header-nav-select-item-mob"
                >
                  <div v-html="item.name"></div>
                </div></div
            ></span>
          </RouterLink>
        </nav>
        <div
          class="mail-box"
          @click="openPopupForm"
        >
          <div class="icon-mail">
            <img
              :src="popup.image"
              :alt="popup.code"
            />
          </div>
          <span>{{ popup.name }}</span>
        </div>
      </div>
    </transition>
    <!-- popup form -->
    <popup
      v-if="isOpenPopup"
      v-model:open.sync="isOpenPopup"
      :form-content="form"
      :type="'form'"
      :isMenuForm="true"
      :formMessage="messages"
      class="form-popup-wr"
    />
  </div>
</template>

<script>
import { HTTP, Routes } from '../api/API';
import Popup from './Popup.vue';
import { noScroll } from '../main';

export default {
  components: {
    Popup,
  },
  props: {
    langContent: { type: String, default: 'ru' },
    scrolled: {type: Boolean, default: false}
  },
  data() {
    return {
      languages: null,
      links: [],
      logo: {},
      popup: {},
      avardBtn: {},
      linkHome: '',
      isOpenPopup: false,
      form: {},
      contentMenu: [],
      messages: [],
      isOpenMenu: false,
      isMob: window.innerWidth < 1023 ? true : false,
    };
  },
  computed: {},
  created() {},
  mounted() {
    this.getContent();
  },
  updated() {},
  methods: {
    openMenu() {
      this.isOpenMenu = !this.isOpenMenu;
      noScroll(this.isOpenMenu);
    },
    openPopupForm() {
      this.isOpenPopup = !this.isOpenPopup;
    },
    clickSubLink(link) {
      this.$router.push({ name: 'assortment', params: { fishfeeds: link } });
      this.isOpenMenu = !this.isOpenMenu;
      if(this.isMob){
        noScroll(this.isOpenMenu);
      }
      
    },
    // Изменение языка
    changeLanguage(lang) {
      localStorage.lang = lang.code;
      // запись в url
      const arUrl = window.location.pathname.split('/');
      arUrl[1] = lang.code;
      const newArUrl = arUrl.join('/');
      const newUrl = window.location.origin + newArUrl;
      history.pushState('', '', newUrl);
      location.reload(); //перезагрузка страницы
    },
    getContent() {
      HTTP.get(Routes.homePage)
        .then(response => {
          this.messages = response.data.data.messages;
          const home = response.data.data.content;
          home.forEach(item => {
            switch (item.type) {
              case 'form':
                this.form = item;
                break;
              case 'menu':
                this.contentMenu = item.items;
                // console.log('this.contentMenu: ', this.contentMenu);
                this.logo = this.contentMenu.logo;
                this.linkHome = this.logo.link.href;
                this.avardBtn = this.contentMenu.btn;
                this.links = this.contentMenu.links;
                this.languages = this.contentMenu.lang;
                this.popup = this.contentMenu.popup;
                break;
              default:
                break;
            }
          });
        })
        .catch(error => {
          console.log(error);
        });
    },
  },
};
</script>
